/*
JS that handle modules linked to contacting elected officials
*/
//import { store } from 'https://unpkg.com/@startinblox/core@0.10';


//listen form DOM load
document.addEventListener('DOMContentLoaded', (e) => {
    const actionPage = document.querySelectorAll("#action-group-detail");
    /*********
     Launch Action Page scripts & listeners
    ********/
   actionPage.forEach((page) => {
        /**
         * "Navigation Listener
            * "Use first display populate to launchers
         */
        let firstDisplay = page.querySelector("solid-display");
        firstDisplay.addEventListener("populate",() => {
            //display representatvie contact CTA's that are chosen
            hideContactRepresentativeSections(page);
            //hide contact modules
            hideContactRepresentativeModules(page);
            let actionSearches = page?.querySelectorAll("solid-form-search");
            //console.log("search modules",actionSearches);
            if (actionSearches != null) {
                actionSearches.forEach(actionSearch => {
                    actionSearchName = actionSearch.attributes.name;
                    if (actionSearchName) {
                        if (actionSearchName.value ==  "action-representative-postal-search") {
                            setTimeout(() => {
                                // console.log('action page search listener');
                                actionPageSearchListener(page,actionSearch);
                            }, 1000);
                            // representativeContactAction(page,searchModule);
                        } 
                        else{
                            //console.log("search module name",actionSearchName.value);
                        }
                    }
                });
            }
        });
        /**
         * Listen to forms of action page 
         */
        let actionForms = page.querySelectorAll("solid-form");
        actionForms.forEach(form => {
            if (form) {
                form.addEventListener("populate",() => {
                    //console.log("loading the form",form);                
                    let formName = form.attributes.name;
                    if(!formName) {
                        //TODO: HIDE FORM IF EMPTY MANAGEMENT
                        //console.log("this form has no name");
                    }
                    //Representative Email form
                    else if (formName.value.includes("representative-email") ) {
                        /*
                         * Form click listener
                         */

                        //add event listener for "send" click in order to improve dialog
                        formSubmit = form.querySelector("input[type=submit]")
                        formSubmit.addEventListener("click",() => {
                            //load action url in form now
                            loadActionUrl(page,form);
                            // updateEmailWithSelectedRepresentatives(form);
                            displayEmailInDialog(form);
                            
                            dialogSubmitButton = form.querySelector('dialog  button:first-child') 
                            //listen to click on submit form in order to display 'email sent' dialog
                            dialogSubmitButton.addEventListener("click",() => {
                                displayEmailSentDialog(form);
                            })
                        })
                    }
                });
            }
            else{
                //console.log("there's no form");
            }
        });
        /**
         * Listen to displays of action page
         */
        let actionDisplays = page.querySelectorAll("solid-display");
        actionDisplays.forEach(actionDisplay => {
            actionDisplay.addEventListener("populate",(displayPopulateEvent) => {
               
                // displayPopulateEvent.preventDefault;
                // displayPopulateEvent.cancelBubble;
                // displayPopulateEvent.stopImmediatePropagation();    
                let displayName = actionDisplay?.attributes?.name;
                if (displayName) {
                    //email content display
                    if (displayName.value=='email-counter-display') {
                        setTimeout(() => {
                            emailSentCounter(actionDisplay);
                        }, 500);
                    }
                    else if (displayName.value=='action-hostname') {
                        setTimeout(() => {
                            let currentHostName = window.origin;
                            let actionOriginHostName = document.querySelector("*[name='instanceHostName']")?.textContent;
                            //if the action has been launched by current site, hide instance info below
                            // console.log("Federation block visibility",currentHostName,actionOriginHostName);
                            let federatedActionInfoBlock = document.querySelector('solid-display[name=federated-action-information]');
                            if (currentHostName == actionOriginHostName) {
                                federatedActionInfoBlock.style.display = "none"
                            }
                            else{
                                federatedActionInfoBlock.style.display = "block"
                            }
                        }, 0);
                        setTimeout(() => {
                        //add domain to search field
                        addFederatedInstaceDataSource('action-page-representative-search','/search-representative/')
                        // //add domain to contact form
                        addFederatedInstaceDataSource('manual-representative-email-send-form','/electedofficialcontacts/')
                        addFederatedInstaceDataSource('representative-email-send-form','/electedofficialcontacts/')
                    }, 2000); //increase to delay to reduce impact of distant sources on load time 
                    }
                }
            });
            // if(actionDisplay?.attributes?.name?.value=='action-page-representative-search'){
            //     setTimeout(() => {
            //     }, 2000);
            // }
        });
    });
});


/**
 * Add original instance name to data sources to make sure posts are sent there
 * @param {*} containerId - container to update
 * @param {*} wantedUri - URI of the resource wanted
*/
function addFederatedInstaceDataSource(containerName,wantedUri){
    const originalActionDomain = document.querySelector("*[name='instanceHostName']")?.textContent;
    containerToUpdate = document.querySelectorAll("*[id="+containerName+"]")
    containerToUpdate.forEach(container => {
        container.dataset.src  = originalActionDomain + wantedUri;
    });
}   



function actionPageSearchListener(page,searchForm){
    let submitButton = searchForm?.querySelector("input[type=submit]");
    submitButton.addEventListener("click",() => {
        //update button text
        submitButton.value = 'Mettre à jour';

        //hide modules CtA's & lines
        let modulesToHideIds = [
            'representative-contact-modules',
            'representative-contact-content-email',
            'representative-contact-content-twitter',
            'representative-contact-content-call'
        ]
        modulesToHideIds.forEach(modulesToHideId => {
            let moduleLine = page?.querySelector('#'+modulesToHideId);
            moduleLine.style.display = 'none';
        });
        
        
        //display representatives CTA's
        let targetedOfficialsChoiceBar = page?.querySelector('#display-choose-officials');
        //console.log("officials are",targetedOfficialsChoiceBar);
        targetedOfficialsChoiceBar.style = 'block';
        targetedOfficialsChoiceBar.display = 'block';
        
        window.setTimeout(() => {
            targetedOfficialsChoiceBar.style.opacity = 1;
            targetedOfficialsChoiceBar.style.transform = 'scale(1)';
        },0);
    });
}

function addChosenRepresentativesToEmail(form){
    //get user name & last name

    //get chosen representatives names
    let representativeSearchSection = form.closest('section').previousElementSibling;
    let listedRepresentatives = representativeSearchSection.querySelectorAll('solid-display[class="representative-search"] > div > solid-display');

    let representativeNames = []
    listedRepresentatives.forEach(representative => {
        let chosenStatus = representative?.querySelector('u4e-display-checkbox input')?.checked;
        if (chosenStatus == true) {
            let fullName = representative.querySelector("div[name=fullname]").innerText; 
            representativeNames.push(fullName)
        }
    });
    representativeNames = representativeNames.join(', ')

    let emailContent = form.querySelector("textarea[name=content]").value
    // representativePlaceholders = [
    //     '[Madame la députée - Monsieur le député]',
    //     '[Madame',
    //     'Madame]',
    //     'Monsieur]',
    //     '[Monsieur'
    // ]
    let representativePlaceholder = emailContent.replace('[Madame/Monsieur]',representativeNames)
    form.querySelector("textarea[name=content]").value =  representativePlaceholder
}

/*****
    * On email send, add content of email to validation dialog
    @params solid-display
*****/
function displayEmailInDialog(form){
    let formDialog = form.querySelector("dialog");
    //check if there's already content added to dialog, if so, remove it
    let contentInDialog = formDialog?.querySelector('#representative-email-review');
    if (contentInDialog != null) {
        let formDialogText = formDialog.querySelector(":scope > p")
        formDialogText.removeChild(contentInDialog);
    }
    //customize email:
    addChosenRepresentativesToEmail(form)
    let dialogDiv = document.createElement("div");

    // let newTitleTag = document.createElement("h3");
    // let newTitleText= document.createTextNode("Vous allez envoyez l'email suivant:");
    // newTitleTag.appendChild(newTitleText);

    let emailSubjectTag = document.createElement("p");
    let currentSubject = form.querySelector("input[name=subject]").value
    let emailSubjectText = document.createTextNode(currentSubject);
    emailSubjectTag.appendChild(emailSubjectText);
    
    let emailContentTag = document.createElement("p"); 
    let currentContent = form.querySelector("textarea[name=content]").value;
    //console.log("content",currentContent);
    // emailContentTag.appendChild(emailContentText);
    
    
    let existingDialogTitle = form.querySelector("dialog > p");
    existingDialogTitle.appendChild(dialogDiv);
    dialogDiv.id = 'representative-email-review'
    // dialogDiv.appendChild(newTitleTag);
    // newTitleTag.classList.add('mt-2')
    dialogDiv.appendChild(emailSubjectTag);
    emailSubjectTag.classList.add('bold','pb-0');
    dialogDiv.appendChild(emailContentTag);
    emailContentTag.innerText += currentContent.toString();
    

    //listen for click & validation text 
    let formButtons = form.querySelectorAll("dialog  button")
    //console.log("form dialog buttons",formButtons);
    formButtons.forEach(button => {
        button.addEventListener("click",() => {
            let formDialogText = formDialog.querySelector(":scope > p")
            //console.log("click",button);
            let addedContents = formDialog.querySelectorAll('#representative-email-review')
            addedContents.forEach(addedContent => {
                formDialogText.removeChild(addedContent);
            });
        }); 
    });
}

/*****
    * On email send, display email sent dialog
    @params solid-form
*****/
function displayEmailSentDialog(form){
    console.log('email sent',form);
    validationDialog = document.querySelector('dialog#representative-email-sent');
    validationDialog.style.display = 'flex';
}

/*****
    * Display counter of emails sent
    @params solid-display
*****/
function emailSentCounter(actionDisplay){
    let numberOfParticipants = document.querySelector("#numberOfParticipants").innerHTML;
    numberOfParticipants = parseInt(numberOfParticipants);                  
    let totalParticipants = 10;
    //Adapt total number when participants reached
    if (numberOfParticipants >= totalParticipants) {
        //if we're at 100%, update total to next goal
        if ((numberOfParticipants/totalParticipants)==1){
            totalParticipants = totalParticipants +1;
        }
        totalParticipants = Math.ceil(numberOfParticipants /100.0)*100;
        actionDisplay.querySelector("#totalParticipants").innerText = totalParticipants;
    }
    else{
        actionDisplay.querySelector("#totalParticipants").innerText = totalParticipants;
    }
    //calculate the percentage of sents vs totals
    var percentageOfTotal = (numberOfParticipants/totalParticipants)*100;

    //plug it into the percentage bar
    //progress bar source code: https://codepen.io/vitoralberto/pen/raqZpE
    $({
        countNum: $('.bar p').html()
    }).animate({
        countNum: percentageOfTotal.toFixed(2)
    }, {
        duration: 3000,
        easing: 'linear',
        step: function() {
        $('.bar p').html(Math.floor(this.countNum) + "%");
        $(".bar").css("width", Math.floor(this.countNum) + "%");
        },
        complete: function() {
        $('.bar p').html(this.countNum + "%");
        $('.bar').css("width", this.countNum + "%");
        // alert('finished');
        }
    });
}

/***********************
 * REPRESENTATIVE CONTACT CTA'S
    * Display Module CTAS
    * Hide existing modules if displayed
    * @param {*} clicLocation Clic element 
    * @param {*} representativeFunction section id 
**********************/
function clickDisplaySelectedOfficialsCTA(clicLocation,representativeFunction){
    //console.log("function",representativeFunction);
    let representativeModulesCTAs = document.querySelector('#representative-contact-modules');
    let visibilityStatus = representativeModulesCTAs.style.display;
    //uncheck previously checked radio buttons
    let radioButtons = representativeModulesCTAs.querySelectorAll('input[type=radio]')
    radioButtons.forEach(radioButton => {
        radioButton.checked = false;
    });
    //if hidden, then just display
    if (visibilityStatus == '' || visibilityStatus == 'none') {
        representativeModulesCTAs.style.display = 'block';
    }
    //if the block is already displayed, then hide existing elements
    //&& re-display just CTA's 
    else if (visibilityStatus == 'block'){
        //hide contact modules elements
        let contactModules = document.querySelectorAll('#representative-contact-content-email,#representative-contact-content-twitter,#representative-contact-content-call');
        contactModules.forEach(contactModule => {
            contactModule.style.display = 'none';
        });
        //hide cta line
        representativeModulesCTAs.style.display = 'none';
        setTimeout(() => {
            //reload cta line
            representativeModulesCTAs.style.display = 'block';
        }, 500);
    }
}

/***********************
 * HIDE REPRESENTATIVE CONTACT SECTION 
 * In case section was opened on another action
**********************/
function hideContactRepresentativeSections(page) {
    let contactRepresentativeSections = page.querySelectorAll(".elected-officials-contact > div");
    //console.log("contact representative sections",contactRepresentativeSections);
    contactRepresentativeSections.forEach(contactRepresentativeSection => {
        contactRepresentativeSection.setAttribute("style","display:none");
        //console.log("contact section",contactRepresentativeSection,contactRepresentativeSection.attributes);
    });
}


/***********************
 * HIDE REPRESENTATIVE CONTACT Modules 
 * In case section was opened on another action
**********************/
function hideContactRepresentativeModules(page) {
    let contactRepresentativeModules = page.querySelectorAll("*[id=display-choose-officials]");
    //console.log("contact representative Modules",contactRepresentativeModules);
    contactRepresentativeModules.forEach(contactRepresentativeModule => {
        contactRepresentativeModule.setAttribute("style","display:none");
        //console.log("contact Module",contactRepresentativeModule,contactRepresentativeModule.attributes);
    });
}
/*========================
 *  REPRENSENTATIVE CONTACT 
    - Onclick "Email/Twitter" display module  
===========================*/
/* Display the content
 */
function displayContactModule(targetingType,contentId){
    // console.log("display block",targetingType,contentId);
    let moduleSectionIds = "Global"
    if (targetingType.toLowerCase().includes('manual') ) {
        moduleSectionIds = {
            'email' : 'manual-contact-content-email',
            'twitter' : 'manual-contact-content-twitter',
            'phone' : 'manual-contact-content-call'
        }
        //just for Manual selection, load email & twitter values here
        customizeRepresentativeContent('manual-targeting')
    } else {
        moduleSectionIds = {
            'email' : 'representative-contact-content-email',
            'twitter' : 'representative-contact-content-twitter',
            'phone' : 'representative-contact-content-call'
        }
    }
    if (contentId.toLowerCase().includes('email')) {
        contentId =  moduleSectionIds['email']
      }else if (contentId.toLowerCase().includes('twitter')) {
        contentId =  moduleSectionIds['twitter']
      }else if (contentId.toLowerCase().includes('téléphone')) {
        contentId =  moduleSectionIds['phone']
      } 
      else {
        
      }
    let moduleContent = document.querySelectorAll("#"+contentId); 
    moduleContent.forEach(module => {
      let blockDisplay = module.style.display;
      if (blockDisplay == 'none'){
        //console.log("display");
        module.style.display = 'block';
        window.setTimeout(() => {
          module.style.opacity = 1;
          module.style.transform = 'scale(1)';
        },0);
        
      }
      else{
          module.style.opacity = 0;
          module.style.transform = 'scale(0)';
          window.setTimeout(() => {
              module.style.display = 'none';
            },700);
        }
    });
}

/*********
    Email Linked action
    * Push action number to the nested field linked
**********/
function loadActionUrl(page,forms){
    page = page;
    forms = forms;
    //get data src of first display of page
    let actionDataSource = page.querySelector("solid-display").dataset.src;
    //console.log("action data src",actionDataSource);
    //push it to value in form
    if (NodeList.prototype.isPrototypeOf(forms) == false ) {
        let form = forms;
        let formActionField = form.querySelector("input[name='linkedAction']");
        //console.log("form field",formActionField);
        formActionField.setAttribute(
            "value",
            JSON.stringify({ "@id": actionDataSource })
        );
    }
    else{
        forms.forEach(form => {
            let formActionField = form.querySelector("input[name='linkedAction']")
            //console.log("load url to form",form,formActionField);
            //formActionField.value = actionDataSource;
            //console.log("form field",formActionField);
            formActionField.setAttribute(
              "value",
              JSON.stringify({ "@id": actionDataSource })
            );
        });
    }
}

/**
 * Customize content depending on target 
 *  Replaces old content loader loadEmailContent() and loadTweet()
 * 
 * @param {*} representativeFunction what type of representative are we targeting
*/
function customizeRepresentativeContent(representativeFunction) {
    //console.log("representative",representativeFunction);
    //get different values possible & place them in case
    representativeFunction = representativeFunction.toLowerCase();
    if (representativeFunction.includes('déput')) {
        representativeFunction = 'representative';
    }
    else if (representativeFunction.includes('sénat')) {
        representativeFunction = 'senator';
    }
    else if (representativeFunction.includes('candi')) {
        representativeFunction = 'candidate';
    }
    else if (representativeFunction.includes('manual')) {
        // console.log("manual targeting");
        representativeFunction = 'manual';
    }
    loadTargetedRepresentativeEmails(representativeFunction);
    loadTargetedRepresentativeTwitter(representativeFunction);
}
/**
 * Customize email content
 * sub function started by customizeRepresentativeContent
 * @param {*} representativeFunction what type of representative are we targeting
 */
function loadTargetedRepresentativeEmails(representativeFunction) {
    //needed vars
    let emailSubject = ""
    let emailContent = ""
    // get the content in the solid display
    switch (representativeFunction) {
        case 'representative':
            emailSubject = document.querySelector('div[name="electedofficialEmailSubject"]').textContent;
            emailContent = document.querySelector('div[name="electedofficialEmailText"]').textContent;
            break;
        case 'senator':
            emailSubject = document.querySelector('div[name="senatorEmailSubject"]').textContent;
            emailContent = document.querySelector('div[name="senatorEmailText"]').textContent;
            break;
        case 'candidate':
            emailSubject = document.querySelector('div[name="candidateEmailSubject"]').textContent;
            emailContent = document.querySelector('div[name="candidateEmailText"]').textContent;
            break;
        case 'manual':
            emailSubject = document.querySelector('div[name="targetedEmailSubject"]').textContent;
            emailContent = document.querySelector('div[name="targetedEmailText"]').textContent;
            break
        
        default:
            break;
    }
    // get the fields in the form
    let emailForm = ""
    if (representativeFunction == 'manual') {
        emailForm = document.querySelector('#manual-representative-email-send-form');
        
    }
    else{
        emailForm = document.querySelector('#representative-email-send-form');

    }
    let subjectField = emailForm.querySelector('input[name="subject"]');
    let contentField = emailForm.querySelector('textarea[name="content"]');
    // push the new content
    subjectField.value = emailSubject.trim();
    contentField.value = emailContent.trim();
}

function loadTargetedRepresentativeTwitter(representativeFunction) {
    // console.log("loading targeted twitter",representativeFunction);
    //vars needed
    let tweet1 = ""
    let tweet2 = ""
    let tweet3 = ""
    let tweet4 = ""
    //get the content depending on target type
    switch (representativeFunction) {
        case 'representative':
            tweet1 = document.querySelector('solid-display-value[name="TweetMain"]').textContent;
            tweet2 = document.querySelector('solid-display-value[name="Tweet2"]').textContent;
            tweet3 = document.querySelector('solid-display-value[name="Tweet3"]').textContent;
            tweet4 = document.querySelector('solid-display-value[name="Tweet4"]').textContent;
            break;
        case 'senator':
            tweet1 = document.querySelector('solid-display-value[name="senatorTweetMain"]').textContent;
            tweet2 = document.querySelector('solid-display-value[name="senatorTweet2"]').textContent;
            tweet3 = document.querySelector('solid-display-value[name="senatorTweet3"]').textContent;
            tweet4 = document.querySelector('solid-display-value[name="senatorTweet4"]').textContent;
            break;
        case 'candidate':
            tweet1 = document.querySelector('solid-display-value[name="candidateTweetMain"]').textContent;
            tweet2 = document.querySelector('solid-display-value[name="candidateTweet2"]').textContent;
            tweet3 = document.querySelector('solid-display-value[name="candidateTweet3"]').textContent;
            tweet4 = document.querySelector('solid-display-value[name="candidateTweet4"]').textContent;
            break;
        
        case 'manual':
            tweet1 = document.querySelector('solid-display-value[name="targetedTweetMain"]').textContent;
            tweet2 = document.querySelector('solid-display-value[name="targetedTweet2"]').textContent;
            tweet3 = document.querySelector('solid-display-value[name="targetedTweet3"]').textContent;
            tweet4 = document.querySelector('solid-display-value[name="targetedTweet4"]').textContent;
            break;

        default:
            break;
    }
    //display content in html
    let twitterSection  = ""
    if (representativeFunction == 'manual') {
        twitterSection = document.querySelector('#manual-twitter-module')
    } else {
        twitterSection = document.querySelector("#twitter-module");
    }
    twitterSection.querySelector("div#tab-1 p").textContent = tweet1;
    twitterSection.querySelector("div#tab-2 p").textContent = tweet2;
    twitterSection.querySelector("div#tab-3 p").textContent = tweet3;
    twitterSection.querySelector("div#tab-4 p").textContent = tweet4;
}

/* ACTION FORM 
When click "validate", get the user choices & display the blocs*/
function actionFormSelection(click){
    //select targeted repesentative choices
    //console.log("location of clic",click);
    let targetingBlock = click.parentElement.parentElement;
    let targetedSelectionField = targetingBlock.querySelector("select[name=targetedOfficials]");
    let chosenRepresentatives = targetedSelectionField.nextElementSibling.querySelectorAll(".ss-value-text");
    let chosenRepresentativesValues = []
    
    //console.log("form selection",targetedSelectionField,chosenRepresentatives);
    //select targeted mediums
    let targetingPlateformsField = targetingBlock.querySelector("select[name=contactPlateforms]");
    let chosenPlateforms = targetingPlateformsField.nextElementSibling.querySelectorAll(".ss-value-text");
    let targetingPlateformsValues = []
    //select ways of selected representatives 
    var targetingChoice =  document.querySelector(".representativeTargetingOption select");
    

    let representatives = false;
    let senators = false;
    let candidates = false;
    let twitterChoice = false;
    let emailChoice =  false;
    let phoningChoice = false;

    //for each representative type, display the chosen options
    chosenRepresentatives.forEach(chosenRepresentative => {
        chosenRepresentative = chosenRepresentative.innerText;
        chosenRepresentative = chosenRepresentative.toLowerCase();
        
        chosenRepresentativesValues.push(chosenRepresentative);
        //console.log("reps is",chosenRepresentative);
        if (chosenRepresentative.includes('sénat')){
            senators = true;
        }
        else if (chosenRepresentative.includes('déput')){
            representatives = true;
        }
        else if (chosenRepresentative.includes('candidat')){
            candidates = true;
        }
    });
    //get values of chosen options
    chosenPlateforms.forEach(chosenPlateform => {
        chosenPlateform = chosenPlateform.innerText;
        chosenPlateform = chosenPlateform.toLowerCase();
        targetingPlateformsValues.push(chosenPlateform);
        if (chosenPlateform.includes('twitter')){
            twitterChoice = true;
        }
        else if (chosenPlateform.includes('email')){
            emailChoice = true;
        }
        else if (chosenPlateform.includes('phone')){
            phoningChoice = true;
        }
        else{
            window.alert("Veuillez choisir une plateforme d'interpellation");
        }
        
    });

    //console.log("chosen reps",chosenRepresentativesValues,targetingPlateformsValues,"choices :",senators,representatives,candidates);
    
    //Select each section
    let senatorSections = document.querySelectorAll('solid-set-default[name=senatorSection]');
    let representativeSections = document.querySelectorAll('solid-set-default[name=representativeSection]');
    let candidateSections = document.querySelectorAll('solid-set-default[name=candidatesSection]');
    
    //If senators are selected, display sections
    if (senators == true) {
        displayChosenSection(senatorSections,"solid-set-default[name=twitterSection]","solid-set-default[name=emailSection]");
    }
    else{
        hideEmptySection(senatorSections);
    }
    //If representatives are selected, display sections 
    if (representatives == true) {
        displayChosenSection(representativeSections,"solid-set-default[name=line-6]","solid-set-default[name=line-7]");
    }
    else{
        hideEmptySection(representativeSections);
    }
    //If candidates are selected, display sections 
    if (candidates == true) {
        displayChosenSection(candidateSections,"solid-set-default[name=candidatTwitterSection]","solid-set-default[name=candidatEmailSection]");
    }
    else{
        hideEmptySection(candidateSections);
    }
    

    function displayChosenSection(chosenElectedOfficials,twitterBlockSelector,emailBlockSelector) {
        chosenElectedOfficials.forEach(chosenElectedOfficial => {     
            //console.log("Chosen rep is",chosenElectedOfficial);
            //if twitter is selected, display fields
            chosenElectedOfficial.style.display = "block";
            var twitterBlocks = document.querySelectorAll(twitterBlockSelector);
            twitterBlocks.forEach(twitterBlock => {
                var twitterBlockSeperator = twitterBlock.nextElementSibling;
                //console.log("twitter block is",twitterBlock);
                if (twitterChoice == true ){
                    twitterBlock.style.display = "block";
                    twitterBlockSeperator.style.display = "block";
                }
                else{
                    twitterBlock.style.display = "none";
                    twitterBlockSeperator.style.display = "none";
                }    
            });
            //Email visibility 
            var emailBlocks = document.querySelectorAll(emailBlockSelector);
            emailBlocks.forEach(emailBlock => {
                var emailBlockSeperator = emailBlock.nextElementSibling;
                if (emailChoice == true){
                    //console.log("representative email selected");
                    emailBlock.style.display = "block";
                    emailBlockSeperator.style.display = "block";     
                }
                else{
                    emailBlock.style.display = "none";
                    emailBlockSeperator.style.display = "none";
                }
            });
        });
    }
    function hideEmptySection(electedOfficialSections){
        electedOfficialSections.forEach(electedOfficialSection => {
            electedOfficialSection.style.display = "none";
        });
    }
    //if the phoning section is chosen display it
    var phoningBlocks = document.querySelectorAll("solid-set-default[name*=phoning-section]");
    //console.log("phone blocks are",phoningBlocks);
    phoningBlocks.forEach(phoningBlock => {
        var phoningBlockSeperator = phoningBlock.nextElementSibling;
        if (phoningChoice == true ){
            phoningBlock.style.display = "block";
            phoningBlockSeperator.style.display = "block";
        }
        else{
            phoningBlock.style.display = "none";
            phoningBlockSeperator.style.display = "none";
        }    
    });

    //if the user selects to filter display fields
    if (targetingChoice == true){
        var filteringBlock = document.querySelector("solid-set-default[name=line-8]");
        var filteringBlockSeperator = filteringBlock.nextElementSibling;

        //console.log("options",targetingChoice,targetingChoice.selectedOptions);
        //console.log("targeting block",filteringBlock);
        //display solid-set-default 
        if (targetingChoice.selectedOptions[0].value.includes("filter") == true){
            filteringBlock.style.display = "block";
            filteringBlockSeperator.style.display = "block";
            //display following seperator
        }
        else if(targetingChoice.selectedOptions[0].value.includes("filter") == false){
            filteringBlock.style.display = "none";
            filteringBlockSeperator.style.display = "none";
        }
    }
  }